//+------------------------------------------------------------------+
//|                                              TestShiftCanvas.mq5 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#include <Canvas\iCanvas.mqh> //https://www.mql5.com/ru/code/22164

input int _shiftX = -1;
input int _shiftY = -1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit() {
   EventSetMillisecondTimer(30);
   Canvas.Erase(0x00FFFFFF);
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTimer() {
   int r=10+rand()%100;
   Canvas.FillCircle(rand()%(_Width-2*r)+r,rand()%(_Height-2*r)+r, r,Canvas.Grad(rand()/32767.0)&0x80FFFFFF);
   //ulong t= GetMicrosecondCount();
   Canvas.ShiftCanvas(_shiftX,_shiftY);
   //t=GetMicrosecondCount()-t;
   //Comment(t);
   Canvas.Update();
   
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[]) {
//---
//--- return value of prev_calculated for next call
   return(rates_total);
}

